/*############################################################################
#                                                                            #
#             dICuTexas Instruments INA226vphCo               #
#                                                                            #
#@RpCmFFAtmelStudio 6.1(SP2)                                  #
#                                                                            #
#                                                  2014/02/17 Create by nPYO #
#                                                                            #
############################################################################*/
#define __INA226_C__

#include "ina226.h"
#include "twi_functions.h"

/*****************************************************************************
*									VBUS d擾
* Fvoid
* ߒlFuint32_t mVPʂ̓dl
*****************************************************************************/
uint32_t ina226_voltage( void )
{
	ina226_set_pointer( INA226_REG_BUS_VOLTAGE );	/* WX^I			*/
	uint16_t val = ina226_read();					/* f[^擾			*/
	uint32_t ret = (uint32_t)val * 125UL / 100UL;	/* 1LSB=1.25mV			*/
	return ( ret );
}

/*****************************************************************************
*									d擾
* Fvoid
* ߒlFuint32_t mAPʂ̓dl
*****************************************************************************/
uint32_t ina226_current( void )
{
	ina226_set_pointer( INA226_REG_CURRENT );		/* WX^I			*/
	uint16_t ret = ina226_read();					/* f[^擾			*/
	if ( ret & 0x8000 ) ret = 0U;					/* }CiX͋I0*/
	return ( ret );
}

/*****************************************************************************
*									d͎擾
* Fvoid
* ߒlFuint32_t mWPʂ̓d͒l
*****************************************************************************/
uint32_t ina226_power( void )
{
	ina226_set_pointer( INA226_REG_POWER );			/* WX^I			*/
	uint16_t val = ina226_read();					/* f[^擾			*/
	if ( val & 0x8000 ) val = 0U;					/* }CiX͋I0*/
	uint32_t ret = (uint32_t)val * 25UL;			/* 1step=25mW			*/
	return ( ret );
}








/*****************************************************************************
*								|C^ݒ
* Fuint8_t reg WX^ԍ  0x00 : INA226_REG_CONFIGURATION
*                                 0x01 : INA226_REG_SHUNT_VOLTAGE
*                                 0x02 : INA226_REG_BUS_VOLTAGE
*                                 0x03 : INA226_REG_POWER
*                                 0x04 : INA226_REG_CURRENT
*                                 0x05 : INA226_REG_CALIBRATION
*                                 0x06 : INA226_REG_MASK_ENABLE
*                                 0x07 : INA226_REG_ALERT_LIMIT
*                                 0xff : INA226_REG_DIE_ID
* ߒlFvoid
*****************************************************************************/
void ina226_set_pointer( uint8_t reg )
{
	if ( TWI_transferStart( INA226_TWI_ADDR ,TWI_WRITE ) == 0 ) {
		TWI_write( reg );
		TWI_transferEnd();
	}
}

/*****************************************************************************
*								WX^
* Fuint8_t reg WX^ԍ  0x00 : INA226_REG_CONFIGURATION
*                                 0x05 : INA226_REG_CALIBRATION
*                                 0x06 : INA226_REG_MASK_ENABLE
*                                 0x07 : INA226_REG_ALERT_LIMIT
*		uint16_t data ݃f[^
* ߒlFvoid
*****************************************************************************/
void ina226_write( uint8_t reg ,uint16_t data )
{
	if ( TWI_transferStart( INA226_TWI_ADDR ,TWI_WRITE ) == 0 ) {
		TWI_write( reg );
		TWI_write( (uint8_t)( ( data & 0xff00 ) >> 8 ) );
		TWI_write( (uint8_t)( data & 0xff ) );
		TWI_transferEnd();
	}
}

/*****************************************************************************
*							WX^ǂݏo
* Fvoid
* ߒlFuint16_t 
*****************************************************************************/
uint16_t ina226_read( void )
{
	uint8_t h ,l;

	if ( TWI_transferStart( INA226_TWI_ADDR ,TWI_READ ) == 0 ) {
		h = TWI_read( TWI_ACK );
		l = TWI_read( TWI_NACK );
		TWI_transferEnd();
	} else {
		h = l = 0;
	}

	return ( (uint16_t)h << 8 | l );
}
