/*############################################################################
#                                                                            #
#                      TWI}X^[[h֐                             #
#                                                                            #
#@RpCmFFAtmelStudio 6.1(SP2)                                  #
#                                                                            #
#                                                  2014/02/17 Create by nPYO #
#                                                                            #
##############################################################################
#                                                                            #
#   AVR̓vAbvR𗘗pƒRQ{ȗ\                  #
#     n[hEGAE\tgEGÃ̗[hŗL                         #
#   \tgEGATWȈꍇF_CPU̒`Kv                               #
#                                                                            #
############################################################################*/
#define __TWI_FUNCTIONS_C__

#include "twi_functions.h"

/* ef[^WX^`					*/
#define TWI_SDA_DDR  ( *(volatile uint8_t *)( &TWI_SDA_PIN + 0x01 ) )
#define TWI_SDA_PORT ( *(volatile uint8_t *)( &TWI_SDA_PIN + 0x02 ) )

#define TWI_SCL_DDR  ( *(volatile uint8_t *)( &TWI_SCL_PIN + 0x01 ) )
#define TWI_SCL_PORT ( *(volatile uint8_t *)( &TWI_SCL_PIN + 0x02 ) )

/* n[hEGATWI쓮̃}N`	*/
#if TWI_MODE
	#include <compat/twi.h>
	#define TWI_WAIT_TWINT()  while ( !( TWCR & _BV(TWINT) ) )

/* \tgEGATWI쓮̃}N`	*/
#else
	#include <util/delay.h>

	/* vAbvgp				*/
	#if TWI_IN_PULLUP
		#define TWI_SDA_LOW()  { TWI_SDA_DDR  |= _BV(TWI_SDA_BIT); TWI_SDA_PORT &= ~_BV(TWI_SDA_BIT); }
		#define TWI_SDA_HIGH() { TWI_SDA_PORT |= _BV(TWI_SDA_BIT); TWI_SDA_DDR  &= ~_BV(TWI_SDA_BIT); }

		#define TWI_SCL_LOW()  { TWI_SCL_DDR  |= _BV(TWI_SCL_BIT); TWI_SCL_PORT &= ~_BV(TWI_SCL_BIT); }
		#define TWI_SCL_HIGH() { TWI_SCL_PORT |= _BV(TWI_SCL_BIT); TWI_SCL_DDR  &= ~_BV(TWI_SCL_BIT); }

	/* OvAbvgp				*/
	#else
		#define TWI_SDA_LOW()	{ TWI_SDA_DDR |=  _BV(TWI_SDA_BIT); }
		#define TWI_SDA_HIGH()	{ TWI_SDA_DDR &= ~_BV(TWI_SDA_BIT); }

		#define TWI_SCL_LOW()	{ TWI_SCL_DDR |=  _BV(TWI_SCL_BIT); }
		#define TWI_SCL_HIGH()	{ TWI_SCL_DDR &= ~_BV(TWI_SCL_BIT); }

	#endif	// #if IN_PULLUP

	#define	TWI_SDA_INPUT	( TWI_SDA_PIN & _BV(TWI_SDA_BIT ) )
	#define TWI_WAIT()      _delay_us( 50 );
#endif

/*****************************************************************************
*								TWI f[^
* Fuint8_t ack TWI_ACK / TWI_NACK
* ߒlFuint8_t     Ǎ݃f[^
*****************************************************************************/
uint8_t TWI_read( uint8_t ack )
{
	#if TWI_MODE
		if ( ack == TWI_ACK ) {
			TWCR = _BV(TWEN) | _BV(TWINT) | _BV(TWEA);
		} else {
			TWCR = _BV(TWEN) | _BV(TWINT);
		}
		TWI_WAIT_TWINT();
		return ( TWDR );

	#else
		uint8_t dat = 0;

		for ( uint8_t i = 8 ;i ;i-- ) {
			TWI_SCL_HIGH();
			TWI_WAIT();

			dat <<= 1;
			if ( TWI_SDA_INPUT ) {
				dat |= 1;
			}
	
			TWI_SCL_LOW();
			TWI_WAIT();
		}

		if ( ack == TWI_ACK ) {
			TWI_SDA_LOW();
		} else {
			TWI_SDA_HIGH();
		}

		TWI_SCL_HIGH();
		TWI_WAIT();

		TWI_SCL_LOW();
		TWI_WAIT();

		TWI_SDA_HIGH();

		return ( dat );
	#endif
}

/****************************************************************************
*								TWI f[^o
* Fuint8_t data
* ߒlFuint8_t TWI_ACK / TWI_NACK
*****************************************************************************/
uint8_t TWI_write( uint8_t data )
{
	#if TWI_MODE
		TWDR = data;
		TWCR = _BV(TWEN) | _BV(TWINT);
		TWI_WAIT_TWINT();
		uint8_t sts = TW_STATUS;
		uint8_t ack = ( ( sts == TW_MR_SLA_ACK ) || ( sts == TW_MT_SLA_ACK ) || ( sts == TW_MT_DATA_ACK ) ) ? TWI_ACK : TWI_NACK;
		return ( ack );

	#else
		for ( uint8_t i = 8 ;i ;i-- ) {
			if ( data & 0x80 ) {
				TWI_SDA_HIGH();
			} else {
				TWI_SDA_LOW();
			}

			TWI_SCL_HIGH();
			TWI_WAIT();

			TWI_SCL_LOW();
			TWI_WAIT();

			data <<= 1;
		}

		TWI_SDA_HIGH();
		TWI_SCL_HIGH();
		TWI_WAIT();

		uint8_t ack = ( TWI_SDA_INPUT ? TWI_NACK : TWI_ACK );
		TWI_SCL_LOW();
		TWI_WAIT();
		return ( ack );

	#endif
}

/*****************************************************************************
*								TWI]I
* Fvoid
* ߒlFvoid
*****************************************************************************/
void TWI_transferEnd( void )
{
	//
	// XgbvRfBVo
	//
	#if TWI_MODE
		TWCR = _BV(TWEN) | _BV(TWINT) | _BV(TWSTO);

	#else
		TWI_SDA_LOW();
		TWI_WAIT();

		TWI_SCL_HIGH();
		TWI_WAIT();

		TWI_SDA_HIGH();
		TWI_WAIT();

	#endif
}

/*****************************************************************************
*								TWI]Jn
* Fuint8_t addr AhX( 0x00 ` 0x7f )
*		uint8_t mode TW_READ / TW_WRITE
* ߒlFuint8_t      0:OK !0:NG
*****************************************************************************/
uint8_t TWI_transferStart( uint8_t addr ,uint8_t mode )
{
	//
	// X^[gRfBVo
	//
	#if TWI_MODE
		TWCR = _BV(TWEN) | _BV(TWINT) | _BV(TWSTA);
		TWI_WAIT_TWINT();

	#else
		TWI_SDA_HIGH();
		TWI_WAIT();

		TWI_SCL_HIGH();
		TWI_WAIT();

		TWI_SDA_LOW();
		TWI_WAIT();

		TWI_SCL_LOW();
		TWI_WAIT();
	#endif

	//
	// SLA+RW o
	//
	if ( TWI_write( ( addr << 1 ) | mode ) != TWI_ACK ) {
		TWI_transferEnd();
		return ( 1 );
	}

	return ( 0 );
}

/*****************************************************************************
*								TWI ݒ
* Fvoid
* ߒlFvoid
*****************************************************************************/
void TWI_init( void )
{
	/* f[^ݒíj		*/
	TWI_SDA_DDR &= ~_BV(TWI_SDA_BIT);
	TWI_SCL_DDR &= ~_BV(TWI_SCL_BIT);

	/* vAbvݒ			*/
	#if TWI_IN_PULLUP							/* vAbvL?	*/
		TWI_SDA_PORT |= _BV(TWI_SDA_BIT);
		TWI_SCL_PORT |= _BV(TWI_SCL_BIT);
	#else										/* OvAbvgp	*/
		TWI_SDA_PORT &= ~_BV(TWI_SDA_BIT);
		TWI_SCL_PORT &= ~_BV(TWI_SCL_BIT);
	#endif

	/* n[hEGATWIgp̐ݒ	*/
	#if TWI_MODE

		TWSR = 0;								/* vXP[				*/
		TWBR = TWI_TWBR;						/* SCLNbNxݒ			*/
		TWCR = _BV( TWEN );

	#endif
}
